<template>
  <div class="p-4">
    <n-link :to="'/adminmaster/new'">
    <button class="btn btn-primary flex justify-end mb-2" >ADD BOOK</button>
    </n-link>
    <div class="row justify-start items-center bg-gray-200 mt-2" v-for="(item) in books" v-bind:id="item.id">

<!--      <div class="col-sm-6 col-md-4 col-lg-3 flex justify-center p-4 btn" @click="addBookClick" >-->
<!--        <div class=" cCard rounded-lg" style="pointer-events: none;" >-->
<!--          <div class="imgBox shadow-lg rounded-sm flex flex-wrap justify-center content-center">-->
<!--            <img class="w-10 h-10" src="/ic_add.svg" alt=""/>-->
<!--          </div>-->
<!--        </div>-->
<!--      </div>-->

      <div class="col-md-3 flex justify-center p-4" >
        <div class="cCard  rounded-lg">
          <img class="imgBox object-cover shadow-lg rounded-sm" :src="item.image || '/ic_book_placeHolder.png'" alt=""/>
          <div class="h-full detail p-4 bg-gray-200 box">
            <h3 class="text-xl font-medium">
              {{item.title}}
            </h3>
<!--            <p class="text-xs text-gray-700">Number of Chapter :{{Object.keys(item.chapters).length}}</p>-->
            <p class="text-lg h-full">{{item.description}}</p>

            <div class="see-more flex justify-center mb-4">
              <n-link v-if="typeof item.chapters === 'undefined'" :to="'/'+item.id"><button type="button" class="btn btn-outline-success m-2">ADD</button></n-link>
              <n-link v-else :to="`/adminmaster/${item.id}`"><button type="button" class="btn btn-outline-success m-2">DETAIL</button></n-link>
              <button type="button" class="btn btn-outline-danger m-2" @click="deleteBookClick(item.id)">DELETE</button>
            </div>
          </div>
        </div>
      </div>
      <div class="col-md-9 item-start pl-4 pr-4 ">
        <div class="row flex justify-between">
          <h3 class="text-xl self-center font-medium">
            {{item.title}}
          </h3>
          <div class="">
            <n-link v-if="typeof item.chapters === 'undefined'" :to="'/'+item.id"><button type="button" class="btn btn-outline-success m-2">ADD</button></n-link>
            <n-link v-else :to="`/adminmaster/${item.id}`"><button type="button" class="btn btn-outline-success m-2">EDIT</button></n-link>
            <button type="button" class="btn btn-outline-danger m-2" @click="deleteBookClick(item.id)">DELETE</button>
          </div>
        </div>

         <p class="text-xs text-gray-700 pt-2 pb-2"><strong>Number of Chapter: </strong>{{(Object.keys(item.chapters  || [])).length}}</p>
        <div class="scrolling-touch overflow-scroll h-40">
          <p class="text-lg h-full ">{{item.description}}</p>
        </div>

      </div>
    </div>
  </div>
  </template>
  <script>
  import {mapState,mapGetters,mapMutations,mapActions} from 'vuex'

  export default {
    components: {
    },
    computed:{
      ...mapGetters({
      books:'Books/getBooks'
    }
    )
    },
    mounted() {
      this.fetchBooks()
      //this.$store.dispatch('Books/fetchBooks')
    },
    methods:{
      ...mapActions({
      fetchBooks:'Books/fetchBooks'
      }),
      ...mapMutations({
        addBooks:'Books/addBooks',
        addBook:'Books/ADD_BOOK'
    }),
      addBookClick(){
        var id = 3
        const newBook = {id:id,title:'NEW BOOK',description:'Write discription here',image:'https://d827xgdhgqbnd.cloudfront.net/wp-content/uploads/2016/04/09121712/book-cover-placeholder.png',chapters:[]}
        this.addBook(newBook)
        location.href = location.href + 'new'
      },
      deleteBookClick(bookId){
        this.$store.dispatch('Books/deleteBook',{bookId:bookId})
      },
    }
  }
  </script>

<style>
  .cCard{
    position: relative;
    transform-style: preserve-3d;
    transform: perspective(2000px);
    transition: 1s;
    width: 200px;
    height: 300px;
    box-shadow: 10px 10px 10px rgba(0, 0, 0, 0.2);
    border: 1px solid lightgray ;
  }
  .imgBox{
    position: absolute;
    width: 100%;
    height: 100%;
    z-index: 1;
    background:rgba(255,255,255, 0.7);
  }
  .detail{
    width: 100%;
    height: 100%;
    background: white !important;
    box-shadow:  inset 10px 10px 10px rgba(0, 0, 0, 0.1);
    overflow: hidden;
    border: 1px solid lightgray ;
  }
  .cCard:hover{
    transform: perspective(2000px) rotate(-10deg);
  }

  .cCard:hover .imgBox{
    transform: rotateY(-135deg);
    transition:1s;
  }
  .cCard .imgBox{
    transform-origin: left;
  }
  .cCard .detail{
    position: absolute;
    top:0;
    left: 0;
    background-color: black;
  }
  .see-more{
    width: 100%;
    margin-bottom: 10px;
    position: absolute;
    bottom:0;
    left: 50%;
    margin-left: -50%;

  }



</style>
